/*

Copyright (C) 2019 Werner Taelemans, Belgium

This file is part of Galjoen.

Galjoen is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; version 3 of the License.

Galjoen is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with Galjoen; see the file COPYING.  If not, see
<http://www.gnu.org/licenses/>.

*/

#include<iostream>
#include<iomanip>
#include"../board/cposition.h"
#include"../movegen/movegenerator.h"
#include"../board/hasher.cpp"
#include"../book/book.h"
#include"../common/tables.h"
using namespace std;

//-------------------------------------------------------
//
//           unittest book:
//

void test_book()
{
  bool r=true;
  cout << "Test Book ............................................." << flush;

  Tables tbs;
  ChessPosition cp(tbs);
  Book book;
  string bookname;
  try{
    try{
      bookname="/usr/local/games/galjoen.files/Galjoen.bin";
      book.set_name(bookname);
      book.open();
      book.close();
    }
    catch(...){
      try{
	bookname="/usr/games/galjoen.files/Galjoen.bin";
	book.set_name(bookname);
	book.open();
	book.close();
      }
      catch(...){
	try{
	  bookname="Galjoen.bin";
	  book.set_name(bookname);
	  book.open();
	  book.close();
	}
	catch(...){
	  r=false;
	}
      }
    }
    
    if(r){
      book.set_name(bookname);
      book.open();
      BKmove bkm;
      Move m;
      Hasher<1> hh(tbs);
      cp.newgame();
      hh.init(cp);
      uint64_t h1=hh.hash();
      bkm=book.get_move(h1);
      m=bkm(cp);
      book.close();
    }
  }
  catch(...){r=false;}
  
  if(r){cout << "OK" << endl;}else{cout << "FAIL" << endl;}
}






