/*

Copyright (C) 2019 Werner Taelemans, Belgium

This file is part of Galjoen.

Galjoen is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; version 3 of the License.

Galjoen is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with Galjoen; see the file COPYING.  If not, see
<http://www.gnu.org/licenses/>.

*/

#include<iostream>
#include<iomanip>
#include"../common/numerals.h"
#include"../common/connections.h"
#include"../common/prebb.h"
using std::cout;
using std::endl;
using std::flush;



//-------------------------------------------------------
//
//           unittest connections:
//

void test_connections()
{
  cout << "Test Connections ......................................" << flush;
  bool r=true;
  Connections con;
  

  if(con.closed_line_segment(a1,a8)!=a_file){r=false;}
  if(con.closed_line_segment(h1,h8)!=h_file){r=false;}
  if(con.closed_line_segment(a8,h8)!=rank8){r=false;}
  if(con.closed_line_segment(a1,h1)!=rank1){r=false;}
  if(con.closed_line_segment(a1,h8)!=diagonal){r=false;}
  if(con.closed_line_segment(a8,h1)!=antidiagonal){r=false;}

  if(con.queen_attacks(d4)!=BitBoard{c5,b6,a7,e3,f2,g1,a1,b2,c3,e5,f6,g7,h8,a4,b4,c4,e4,f4,g4,h4,d1,d2,d3,d5,d6,d7,d8}){
    r=false;
    std::cerr << con.queen_attacks(d4).dump() << endl;
  }
  
  
  if(r){cout << "OK" << endl;}else{cout << "FAIL" << endl;}

}






