/*

Copyright (C) 2019 Werner Taelemans, Belgium

This file is part of Galjoen.

Galjoen is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; version 3 of the License.

Galjoen is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with Galjoen; see the file COPYING.  If not, see
<http://www.gnu.org/licenses/>.

*/

#include<iostream>
#include<iomanip>
#include<cmath>
#include"../board/cposition.h"
#include"../eval/pst.h"
#include"../common/tables.h"
using namespace std;

//-------------------------------------------------------
//
//           unittest piece square tables:
//

void test_pst()
{
  cout << "Test PST .............................................." << flush;
  bool r=true;

  {
    Tables tbs;
    ChessPosition cp(tbs);
    cp.newgame();
    PieceSquareTables pst;
    pst.init(cp);
    if(abs(pst.get_score().first)>0.0001){r=false;cout << "error(1)  score=" << pst.get_score().first << endl;}
    if(abs(pst.get_score().second)>0.0001){r=false;cout << "error(2)  score=" << pst.get_score().second << endl;}


    Move m1{e2,e4,normal_move,white_pawn_id,no_piece_id};
    Move m2{b8,a6,normal_move,black_knight_id,no_piece_id};
    Move m3{f1,a6,normal_move,white_bishop_id,black_knight_id};
    Move m4{b7,a6,normal_move,black_pawn_id,white_bishop_id};
    cp.make_move(m1);
    pst.make_move(m1);
    if(!pst.verify_score()){std::cerr << "error 1" << endl;r=false;}
    cp.make_move(m2);
    pst.make_move(m2);
    if(!pst.verify_score()){std::cerr << "error 2" << endl;r=false;}
    cp.make_move(m3);
    pst.make_move(m3);
    if(!pst.verify_score()){std::cerr << "error 3" << endl;r=false;}
    cp.make_move(m4);
    pst.make_move(m4);
    if(!pst.verify_score()){std::cerr << "error 4" << endl;r=false;}
    cp.unmake_move();
    pst.unmake_move(m4);
    if(!pst.verify_score()){std::cerr << "error 4" << endl;r=false;}
    

  }



  if(r){cout << "OK" << endl;}else{cout << "FAIL" << endl;}
}






