/*

Copyright (C) 2019 Werner Taelemans, Belgium

This file is part of Galjoen.

Galjoen is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; version 3 of the License.

Galjoen is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with Galjoen; see the file COPYING.  If not, see
<http://www.gnu.org/licenses/>.

*/

#include<iostream>
#include<iomanip>
#include"../common/numerals.h"
#include"../common/square.h"
using namespace std;

//-------------------------------------------------------
//
//           unittest square:
//

void test_square()
{
  bool r=true;

  {
    Square A(63);
    if(A.name()!="h8"){r=false;}
  }

  {
    Square A(4);
    if(A.name()!="e1"){r=false;}
    if(A.id()!=e1){r=false;}
  }

  {
    Square A(44),B(50);
    if(B<A){r=false;}
    if(B<=A){r=false;}
    if(A>B){r=false;}
    if(A>=B){r=false;}
    if(A==B){r=false;}
  }


  {
    Square A(4);
    if(A.rank()!='1'){r=false;}
    if(A.file()!='e'){r=false;}
    A=h8;
    if(A.rank()!='8'){r=false;}
    if(A.file()!='h'){r=false;}
    if(A.rank_number()!=7){r=false;}
    if(A.file_number()!=7){r=false;}
  }

  {
    Square s=flip(f2);
    if(s!=f7){r=false;}
    s=flip(h1);
    if(s!=h8){r=false;}
    s=flip(a8);
    if(s!=a1){r=false;}
    s=flop(h8);
    if(s!=a8){r=false;}
    s=flop(a1);
    if(s!=h1){r=false;}

    for(Square s=a1;s<=h8;s++){
      if(s!=flip(flip(s))){r=false;}
      if(s!=flop(flop(s))){r=false;}
    }

  }

  cout << "Test Square ..........................................." << flush;
  if(r){cout << "OK" << endl;}else{cout << "FAIL" << endl;}

}






