/*

Copyright (C) 2019 Werner Taelemans, Belgium

This file is part of Galjoen.

Galjoen is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; version 3 of the License.

Galjoen is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with Galjoen; see the file COPYING.  If not, see
<http://www.gnu.org/licenses/>.

*/

#ifndef BOOK_H
#define BOOK_H



#include<fstream>
#include<vector>
#include<string>
#include<utility>
#include"bkrecord.h"
#include"bkmove.h"
#include"../search/timer.h"
using std::vector;
using std::string;
using std::ifstream;
using std::ios_base;
using std::pair;


class Book
{
 private:
  string m_bookname;
  ifstream m_ifs;
  int64_t m_begin{0},m_end{0};
  Timer m_tm;
 
 public:
  Book();
  Book(string);
  ~Book();
  void set_name(string);
  string get_name()const;
  BKmove get_move(uint64_t);
  void open();
  bool is_open()const;
  void close();
};


#endif
