/*

Copyright (C) 2019 Werner Taelemans, Belgium

This file is part of Galjoen.

Galjoen is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; version 3 of the License.

Galjoen is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with Galjoen; see the file COPYING.  If not, see
<http://www.gnu.org/licenses/>.

*/

#ifndef ATTACKS_H
#define ATTACKS_H

#include"magicmoves.h"
#include<array>
using std::array;


class Attacks
{
 private:
  array<BitBoard,64> m_knight_attacks;
  array<BitBoard,64> m_king_attacks;
  MagicMoves m_mm;
 
 public:
  Attacks();
  const BitBoard& knight(const BitBoard&)const;
  const BitBoard& bishop(const BitBoard&,const BitBoard&)const;
  const BitBoard& rook(const BitBoard&,const BitBoard&)const;
  BitBoard queen(const BitBoard&,const BitBoard&)const;
  const BitBoard& king(const BitBoard&)const;

  const BitBoard& knight(const Square&)const;
  const BitBoard& bishop(const Square&,const BitBoard&)const;
  const BitBoard& rook(const Square&,const BitBoard&)const;
  BitBoard queen(const Square&,const BitBoard&)const;
  const BitBoard& king(const Square&)const;
};



#endif

