/*

Copyright (C) 2019 Werner Taelemans, Belgium

This file is part of Galjoen.

Galjoen is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; version 3 of the License.

Galjoen is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with Galjoen; see the file COPYING.  If not, see
<http://www.gnu.org/licenses/>.

*/

#ifndef CONNECTIONS_H
#define CONNECTIONS_H

#include"square.h"
#include"../common/bitboard.h"
#include<array>
using std::array;



class Connections
{

 public:
  Connections();
  const BitBoard& rook_attacks(const Square&)const;
  const BitBoard& bishop_attacks(const Square&)const;
  const BitBoard& queen_attacks(const Square&)const;
  const BitBoard& line_segment(const Square&,const Square&)const;
  const BitBoard& closed_line_segment(const Square&,const Square&)const;

 private:
  array<BitBoard,64> m_rook_attacks;
  array<BitBoard,64> m_bishop_attacks;
  array<BitBoard,64> m_queen_attacks;
  array<array<BitBoard,64>,64> m_line_segment;
  array<array<BitBoard,64>,64> m_closed_line_segment;
};



#endif
