/*

Copyright (C) 2019 Werner Taelemans, Belgium

This file is part of Galjoen.

Galjoen is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; version 3 of the License.

Galjoen is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with Galjoen; see the file COPYING.  If not, see
<http://www.gnu.org/licenses/>.

*/

#include"rookmask.h"
#include"prebb.h"


RookMask::RookMask()
{
  BitBoard temp_bb;
  for(Square s=a1;s<=h8;s++){

    temp_bb.clear();
    temp_bb.set_square(s);
    for(int i=1;i<7;i++)
      {
	temp_bb|=temp_bb<<8;
      }
    temp_bb&=~hborder;
    rm[s.id()]|=temp_bb;

    temp_bb.clear();
    temp_bb.set_square(s);
    for(int i=1;i<7;i++)
      {
	temp_bb|=temp_bb<<1 & not_a_file;
      }
    temp_bb&=~vborder;
    rm[s.id()]|=temp_bb;

    temp_bb.clear();
    temp_bb.set_square(s);
    for(int i=1;i<7;i++)
      {
	temp_bb|=temp_bb>>1 & not_h_file;
      }
    temp_bb&=~vborder;
    rm[s.id()]|=temp_bb;

    temp_bb.clear();
    temp_bb.set_square(s);
    for(int i=1;i<7;i++)
      {
	temp_bb|=temp_bb>>8;
      }
    temp_bb&=~hborder;
    rm[s.id()]|=temp_bb;
    rm[s.id()].reset_square(s);
  }
}


const BitBoard& RookMask::get_mask(Square s)const
{
  return rm[s.id()];
}


