/*

Copyright (C) 2019 Werner Taelemans, Belgium

This file is part of Galjoen.

Galjoen is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; version 3 of the License.

Galjoen is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with Galjoen; see the file COPYING.  If not, see
<http://www.gnu.org/licenses/>.

*/

#ifndef TRANSPOSITION_H
#define TRANSPOSITION_H

#include<vector>
#include<string>
#include<utility>
#include"ttrecord.h"
#include"bucket.h"
using std::string;
using std::vector;
using std::pair;


class TranspositionTable
{
 private:
  Bucket* m_bucket;
  uint64_t m_number_of_buckets;
  uint64_t m_threshold{0};
  bool m_enabled{true};

 public:
  TranspositionTable();
  ~TranspositionTable();
  unsigned char* get_uchar_adress()const;
  int get_size();
  void set_size(int);
  void set_threshold(int);
  int get_threshold()const;
  int hashfull(unsigned char)const;
  void clear();

  bool read(TTrecord&);
  void write(const TTrecord&);

  bool enabled()const;
  void set_enabled(bool);
};


#endif
