/*

Copyright (C) 2019 Werner Taelemans, Belgium

This file is part of Galjoen.

Galjoen is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; version 3 of the License.

Galjoen is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with Galjoen; see the file COPYING.  If not, see
<http://www.gnu.org/licenses/>.

*/

#ifndef TTMOVE_H
#define TTMOVE_H

#include"../common/square.h"
#include"../movegen/move.h"
#include<cstdint>


class ChessPosition;

class TTmove
{
 private:
  uint16_t m_move;

 public:
  TTmove();
  TTmove(uint16_t);
  TTmove(const Move&);
  TTmove& operator=(const Move&);
  Move operator()(const ChessPosition&)const;
  bool operator==(const TTmove&)const;
  bool operator!=(const TTmove&)const;
  bool nomove()const;
  void clear();
  void from(char);
  void to(char);
  Square from()const;
  Square to()const;
  unsigned char code()const;
  Piece piece(const ChessPosition&)const;
  Piece capture(const ChessPosition&)const;
  string algebraic(const ChessPosition&)const;
  const uint16_t& id()const;
};



#endif
