/*

Copyright (C) 2019 Werner Taelemans, Belgium

This file is part of Galjoen.

Galjoen is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; version 3 of the License.

Galjoen is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with Galjoen; see the file COPYING.  If not, see
<http://www.gnu.org/licenses/>.

*/

#include<iostream>
#include<iomanip>
#include<fstream>
#include<sstream>
#include<string>
#include<chrono>
#include<thread>
#include"search/analyze.h"
#include"communicator.h"
#include"engine.h"
#include"console.h"
using std::cout;
using std::endl;
using std::setw;
using std::setprecision;
using std::ostringstream;
using std::istringstream;
using std::runtime_error;
using std::thread;



int main()
{
  ofstream ofs;
  Communicator com;
  Communicator consolecom;
  //consolecom.set_log(true);  
  ConsoleInput consinput(consolecom);
  thread t2(std::ref(consinput));
  Engine eng(com,ofs);

  
  string command,answer;  
  while(true){
    command=consolecom.from_interface();
    
    if(command=="uci"){
      cout << "id name Galjoen 0.40.1" << endl;
      cout << "id author Werner Taelemans" << endl;
      cout << "option name Hash type spin default 128 min 6 max 4096" << endl;
      cout << "option name Threads type spin default 1 min 1 max 2" << endl;
      cout << "option name Ponder type check default true" << endl;
      cout << "option name OwnBook type check default false" << endl;
      cout << "option name UCI_LimitStrength type check default false" << endl;
      cout << "option name UCI_Elo type spin default 2000 min 1500 max 2200" << endl;
      cout << "option name UCI_Chess960 type check default false" << endl;
      cout << "option name MultiPV type spin default 1 min 1 max 256" << endl;
      cout << "option name Debug type check default false" << endl;
      cout << "uciok" << endl;
      continue;
    }else if(command=="quit"){
      t2.join();
      com.to_engine("quit");
      eng.from_console();
      break;
    }else if(command!=""){
      com.to_engine(command);
    }

    //-------------------------
    eng.from_console();
    eng.to_console();
    //-------------------------
    
    answer=com.from_engine();
    if(answer.size()>0){
      cout << answer << endl;
    }
    std::this_thread::sleep_for(std::chrono::milliseconds(5));
  }
  
  return 0;  
}

