/*

Copyright (C) 2019 Werner Taelemans, Belgium

This file is part of Galjoen.

Galjoen is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; version 3 of the License.

Galjoen is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with Galjoen; see the file COPYING.  If not, see
<http://www.gnu.org/licenses/>.

*/

#include<stdexcept>
#include<iostream>
using std::cout;
using std::endl;


MoveList::MoveList()
{
  m_allocate_mem=true;
  m_vm=new Move[256];
}

MoveList::MoveList(Move* px)
{
  m_vm=px;
}

MoveList::MoveList(const MoveList& x)
{
  m_allocate_mem=true;
  m_vm=new Move[256];
  m_size=x.m_size;
  for(size_t i=0;i<m_size;i++){
    m_vm[i]=x.m_vm[i];
  }
}

MoveList::~MoveList()
{
  if(m_allocate_mem){
    delete[] m_vm;
  }
}

const MoveList& MoveList::operator=(const MoveList& x)
{
  m_size=x.m_size;
  for(size_t i=0;i<m_size;i++){
    m_vm[i]=x.m_vm[i];
  }
  return *this;
}

Move& MoveList::operator[](const int& i)
{
  return m_vm[i];
}

const Move& MoveList::operator[](const int& i)const
{
  return m_vm[i];
}

void MoveList::clear()
{
  m_size=0;
}

void MoveList::set_size(int x)
{
  m_size=x;
}

const size_t& MoveList::size()const
{
  return m_size;
}

const Move* MoveList::begin()
{
  return m_vm;
}

const Move* MoveList::end()
{
  return m_vm+m_size;
}

const Move* MoveList::cbegin()const
{
  return m_vm;
}

const Move* MoveList::cend()const
{
  return m_vm+m_size;
}

