/*

Copyright (C) 2019 Werner Taelemans, Belgium

This file is part of Galjoen.

Galjoen is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; version 3 of the License.

Galjoen is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with Galjoen; see the file COPYING.  If not, see
<http://www.gnu.org/licenses/>.

*/

#ifndef HISTORY_H
#define HISTORY_H


#include"../common/piece.h"
#include"../common/square.h"
#include"../movegen/move.h"
#include<vector>
using std::vector;


class HistoryTable
{
 private:
  array<array<int64_t,64>,15> h;

 public:
  HistoryTable();
  void clear();
  void divide_by_8();
  void increment(const Move&,const unsigned int&);
  void decrement(const Move&,const unsigned int&);
  const int64_t& value(const Move&)const;
};

#endif
