/*

Copyright (C) 2019 Werner Taelemans, Belgium

This file is part of Galjoen.

Galjoen is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; version 3 of the License.

Galjoen is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with Galjoen; see the file COPYING.  If not, see
<http://www.gnu.org/licenses/>.

*/

#include"killer.h"




Killer::Killer() : m_killer(max_search_depth,{NullMove(),NullMove()})
{
}

void Killer::clear()
{
  for(auto& k : m_killer){k.first=NullMove();k.second=NullMove();}
}

void Killer::set_killer(int n,const Move& m)
{
  if(m!=m_killer[n].first){
    m_killer[n].second=m_killer[n].first;
    m_killer[n].first=m;
  }
}

Move Killer::get_killerA(int n)const
{
  if(n<0)n=0;
  return m_killer[n].first;
}

Move Killer::get_killerB(int n)const
{
  if(n<0)n=0;
  return m_killer[n].second;
}


