/*

Copyright (C) 2019 Werner Taelemans, Belgium

This file is part of Galjoen.

Galjoen is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; version 3 of the License.

Galjoen is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with Galjoen; see the file COPYING.  If not, see
<http://www.gnu.org/licenses/>.

*/

#include"lmr.h"


LmrTable::LmrTable()
{
  for(int mi=0;mi<256;mi++){m_lmr[0][mi]=1;}
  for(int depth=1;depth<max_search_depth;depth++){
    m_lmr[depth][0]=1;
    for(int mi=1;mi<256;mi++){
      m_lmr[depth][mi]=max(1.0,log(depth)*log(mi/2.0));
    }
  }
}

const char& LmrTable::value(const int& depth, const unsigned int& move)const
{
  return m_lmr[depth][move];
}

char LmrTable::pv_value(const int& depth, const unsigned int& move)const
{
  return m_lmr[depth][move]-1;
}

