/*

Copyright (C) 2019 Werner Taelemans, Belgium

This file is part of Galjoen.

Galjoen is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; version 3 of the License.

Galjoen is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with Galjoen; see the file COPYING.  If not, see
<http://www.gnu.org/licenses/>.

*/

#ifndef MULTIPV_H
#define MULTIPV_H

#include"principal.h"
#include<vector>
using std::vector;


class MultiPV
{
 private:
  unsigned int m_number{1};
  unsigned int m_version{0};
  vector<PrincipalVariation> m_multipv;

 public:
  MultiPV()=default;
  MultiPV(const MultiPV&);
  MultiPV& operator=(const MultiPV&);
  PrincipalVariation& operator[](int);
  const PrincipalVariation& operator[](int)const;
  void clear();
  int version()const;
  void set_version(int);
  void set_number(int);
  int number()const;
  int size()const;
  void add(PrincipalVariation);
  void randomize(int);
  vector<PrincipalVariation>::iterator begin();
  vector<PrincipalVariation>::iterator end();
  vector<PrincipalVariation>::const_iterator cbegin()const;
  vector<PrincipalVariation>::const_iterator cend()const;
};


#endif
