/*

Copyright (C) 2019 Werner Taelemans, Belgium

This file is part of Galjoen.

Galjoen is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; version 3 of the License.

Galjoen is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with Galjoen; see the file COPYING.  If not, see
<http://www.gnu.org/licenses/>.

*/

#ifndef ECOCODES_H
#define ECOCODES_H

#include<cstdint>
#include<array>
#include<tuple>
#include<string>
#include<map>
using std::string;
using std::array;
using std::tuple;
using std::map;


using EcoMap=std::map<uint64_t,string>;

class EcoCodes
{
 private:
  static array<tuple<uint64_t,string,string,string>,2014> ecocodes;
  EcoMap m_eco_code;
  EcoMap m_eco_opening;
  EcoMap m_eco_variation;

 public:
  EcoCodes();
  string eco_code(uint64_t);
  string eco_opening(uint64_t);
  string eco_variation(uint64_t);
};

#endif
