/*

Copyright (C) 2019 Werner Taelemans, Belgium

This file is part of Galjoen.

Galjoen is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; version 3 of the License.

Galjoen is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with Galjoen; see the file COPYING.  If not, see
<http://www.gnu.org/licenses/>.

*/

#ifndef ENGIO_H
#define ENGIO_H

#include<string>
#include<atomic>
#include"../engine/communicator.h"
#include<gtkmm.h>
using std::string;
using std::atomic;


class Engio
{
 private:
  // logging:
  string m_log_filename;
  bool m_log{false};
  ofstream m_ofs;

  // communication:
  Communicator& m_com;
  atomic<bool> m_quit{false};
  string m_engine_filename;
  gint m_in,m_out;
  GPid m_pid;
  int m_engine_id{0};
  bool m_spawned{false};
  bool m_crashed{false};
  
 public:
  Engio(Communicator&);
  ~Engio();
  void operator()();
  void set_engine(string);
  void set_engine_id(int);
  int get_engine_id()const;
  bool good()const;
  bool crashed()const;
  void set_log(bool);
  void log(string);
  void quit();
};




#endif
