/*

Copyright (C) 2019 Werner Taelemans, Belgium

This file is part of Galjoen.

Galjoen is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; version 3 of the License.

Galjoen is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with Galjoen; see the file COPYING.  If not, see
<http://www.gnu.org/licenses/>.

*/

#include"epdw.h"
#include"anaw.h"


EpdCommandsWindow::EpdCommandsWindow()
{
  set_title("EPD");
  set_border_width(5);
  set_default_size(600, 200);
  add(m_ScrolledWindow);
  
  //Add the TreeView, inside a ScrolledWindow, with the button underneath:
  m_TextView.set_editable(false);
  m_TextView.set_cursor_visible(false);
  m_ScrolledWindow.add(m_TextView);
  //Only show the scrollbars when they are necessary:
  m_ScrolledWindow.set_policy(Gtk::POLICY_AUTOMATIC, Gtk::POLICY_AUTOMATIC);

  m_TextBuffer = Gtk::TextBuffer::create();
  m_TextBuffer->set_text("");
  m_TextView.set_buffer(m_TextBuffer);

  show_all_children();
};

EpdCommandsWindow::~EpdCommandsWindow()
{
};

void EpdCommandsWindow::set_text(string x)
{
  clear();
  int i=0;
  for(auto& c : x){
    if( c==';' || (c==' ' && ++i==4) ){
      c='\n';
    }
  }
  Glib::ustring ux=x;
  m_TextBuffer->insert(m_TextBuffer->end(),ux);
  m_TextView.set_buffer(m_TextBuffer);

  auto iter=m_TextBuffer->end();
  m_TextView.scroll_to(iter);
}

void EpdCommandsWindow::clear()
{
  Glib::ustring ux="";
  m_TextBuffer->set_text(ux);
  m_TextView.set_buffer(m_TextBuffer);
}
