/*

Copyright (C) 2019 Werner Taelemans, Belgium

This file is part of Galjoen.

Galjoen is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; version 3 of the License.

Galjoen is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with Galjoen; see the file COPYING.  If not, see
<http://www.gnu.org/licenses/>.

*/

#ifndef GAMELIST_H
#define GAMELIST_H

#include<gtkmm.h>
#include<functional>
#include<string>
using std::string;


class GameList
{
 public:
  GameList(Gtk::Window&);
  ~GameList();

  void clear();
  void add_game(string,string,string,string);
  int get_selection(string);


 protected:
  //Tree model columns:
  class ModelColumns : public Gtk::TreeModel::ColumnRecord
  {
  public:
    ModelColumns()
      { add(m_col_id); add(m_col_white); add(m_col_black); add(m_col_result); add(m_col_date);}
    Gtk::TreeModelColumn<unsigned int> m_col_id;
    Gtk::TreeModelColumn<Glib::ustring> m_col_white;
    Gtk::TreeModelColumn<Glib::ustring> m_col_black;
    Gtk::TreeModelColumn<Glib::ustring> m_col_result;
    Gtk::TreeModelColumn<Glib::ustring> m_col_date;
  };
  ModelColumns m_Columns;

  //Parent window:
  Gtk::Window& m_pw;
  
  //Child widgets:
  Gtk::Box m_VBox;
  Gtk::ScrolledWindow m_ScrolledWindow;
  Gtk::TreeView m_TreeView;
  Glib::RefPtr<Gtk::ListStore> m_refTreeModel;

  int m_game_id{0};
  int m_selection;
};



#endif
