/*

Copyright (C) 2019 Werner Taelemans, Belgium

This file is part of Galjoen.

Galjoen is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; version 3 of the License.

Galjoen is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with Galjoen; see the file COPYING.  If not, see
<http://www.gnu.org/licenses/>.

*/

#ifndef GTKMM_INSTALLDIALOG_H
#define GTKMM_INSTALLDIALOG_H

#include<gtkmm/grid.h>
#include<gtkmm/box.h>
#include<gtkmm/dialog.h>
#include<gtkmm/checkbutton.h>
#include<gtkmm/spinbutton.h>
#include<gtkmm/button.h>
#include<gtkmm/entry.h>
#include<gtkmm/comboboxtext.h>
#include<iostream>
#include<string>
#include"option.h"
#include"engvar.h"
using std::to_string;



class InstallEntry : public Gtk::Entry
{
 private:
  string* ps;
  
 public:
  void set_entry(string* x){ps=x;}
  void on_changed(){
    *ps=get_text();
  }
};


class InstallDialog : public Gtk::Dialog
{
 public:
  InstallDialog(const Glib::ustring&,Gtk::Window&,EngineVariables&);
  virtual ~InstallDialog();

 private:
  static const size_t max_options{100};

  // Signal handlers:
  
  // Widgets:
  Gtk::Box* p_content;
  Gtk::Grid m_grid;
  Gtk::Label m_label[max_options];
  Gtk::Label m_name_label;
  InstallEntry m_name_entry;
  Gtk::Label m_params_label;
  InstallEntry m_params_entry;
  EngineVariables& m_ev;
};



#endif

