/*

Copyright (C) 2019 Werner Taelemans, Belgium

This file is part of Galjoen.

Galjoen is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; version 3 of the License.

Galjoen is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with Galjoen; see the file COPYING.  If not, see
<http://www.gnu.org/licenses/>.

*/

#ifndef INSTALLEDLIST_H
#define INSTALLEDLIST_H

#include<gtkmm.h>
#include<functional>
#include<string>
#include"installengine.h"
using std::string;


class InstalledList
{
 public:
  InstalledList(Gtk::Window&);
  ~InstalledList();

  void clear();
  void add_engine(string);
  string get_selection(InstalledEngines&);


 protected:
  //Tree model columns:
  class ModelColumns : public Gtk::TreeModel::ColumnRecord
  {
  public:
    ModelColumns(){ add(m_col_id); add(m_col_engine);}
    Gtk::TreeModelColumn<unsigned int> m_col_id;
    Gtk::TreeModelColumn<string> m_col_engine;
  };
  ModelColumns m_Columns;

  //Parent window:
  Gtk::Window& m_pw;
  
  //Child widgets:
  Gtk::Box m_VBox;
  Gtk::ScrolledWindow m_ScrolledWindow;
  Gtk::TreeView m_TreeView;
  Glib::RefPtr<Gtk::ListStore> m_refTreeModel;

  int m_engine_id{0};
  string m_selection;
};



#endif
