/*

Copyright (C) 2019 Werner Taelemans, Belgium

This file is part of Galjoen.

Galjoen is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; version 3 of the License.

Galjoen is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with Galjoen; see the file COPYING.  If not, see
<http://www.gnu.org/licenses/>.

*/

#ifndef INSTALLENGINE_H
#define INSTALLENGINE_H

#include"engvar.h"
using std::string;


class InstalledEngines
{
private:
  string m_homedir;
  string m_engines_cfg;
  string m_engines_old;
  std::map<string,EngineVariables> m_engines;
  
public:
  InstalledEngines();
  ~InstalledEngines();
  void read_engines_cfg();
  void write_engines_cfg();
  void install(EngineVariables&);
  EngineVariables& operator[](string x){return m_engines[x];};
  std::map<string,EngineVariables>::iterator begin(){return m_engines.begin();}
  std::map<string,EngineVariables>::iterator end(){return m_engines.end();}
};

#endif
