/*

Copyright (C) 2019 Werner Taelemans, Belgium

This file is part of Galjoen.

Galjoen is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; version 3 of the License.

Galjoen is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with Galjoen; see the file COPYING.  If not, see
<http://www.gnu.org/licenses/>.

*/

#ifndef LEVEL_H
#define LEVEL_H

#include"../engine/search/duration.h"
#include<chrono>
using namespace std::chrono;
using std::milli;
using dura=duration<double,milli>;


class Level
{
 private:
  int m_mps;
  Duration m_base;
  Duration m_inc;

 public:
  bool operator==(const Level&)const;
  bool operator!=(const Level&)const;
  int get_mps();
  Duration get_base();
  Duration get_inc();
  void set_mps(int);
  void set_base(Duration);
  void set_inc(Duration); 
};

#endif
