/*

Copyright (C) 2019 Werner Taelemans, Belgium

This file is part of Galjoen.

Galjoen is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; version 3 of the License.

Galjoen is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with Galjoen; see the file COPYING.  If not, see
<http://www.gnu.org/licenses/>.

*/

#include"pgnview.h"


PgnView::PgnView()
{
  set_title("PGN");
  set_border_width(5);
  set_default_size(600, 400);
  add(m_ScrolledWindow);
  
  m_textview.set_editable(false);
  m_textview.set_cursor_visible(false);
  m_ScrolledWindow.add(m_textview);
  m_ScrolledWindow.set_policy(Gtk::POLICY_AUTOMATIC, Gtk::POLICY_AUTOMATIC);

  m_textbuffer = Gtk::TextBuffer::create();
  m_textbuffer->set_text("");
  m_textview.set_buffer(m_textbuffer);

  show_all_children();
};

PgnView::~PgnView()
{
};

void PgnView::set_text(string x)
{
  m_textbuffer->set_text(x);
}
