/*

Copyright (C) 2019 Werner Taelemans, Belgium

This file is part of Galjoen.

Galjoen is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; version 3 of the License.

Galjoen is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with Galjoen; see the file COPYING.  If not, see
<http://www.gnu.org/licenses/>.

*/

#include"promochoicedraw.h"
#include<cairomm/context.h>
#include<gdkmm/general.h> // set_source_pixbuf()
#include<glibmm/fileutils.h>
#include<iostream>
using std::cout;
using std::endl;


PromoChoiceDraw::PromoChoiceDraw(const PromoChoiceDraw& x)
{
  set_size_request(120,120);
  m_queen=x.m_queen;
  m_rook=x.m_rook;
  m_bishop=x.m_bishop;
  m_knight=x.m_knight;
}

PromoChoiceDraw::PromoChoiceDraw(const Glib::RefPtr<Gdk::Pixbuf>& queen,
				 const Glib::RefPtr<Gdk::Pixbuf>& rook,
				 const Glib::RefPtr<Gdk::Pixbuf>& bishop,
				 const Glib::RefPtr<Gdk::Pixbuf>& knight)
{
  set_size_request(120,120);
  m_queen=queen;
  m_rook=rook;
  m_bishop=bishop;
  m_knight=knight;
}


PromoChoiceDraw::~PromoChoiceDraw()
{
}


bool PromoChoiceDraw::on_draw(const Cairo::RefPtr<Cairo::Context>& cr)
{
  Gtk::Allocation allocation = get_allocation();
  const int width = allocation.get_width();
  const int height = allocation.get_height();
  int h_delta=width/2;
  int v_delta=height/2;
  
  cr->rectangle(0,0,h_delta,v_delta);
  Gdk::Cairo::set_source_pixbuf(cr,m_queen,0,0);
  cr->fill();
  
  cr->rectangle(h_delta,0,2*h_delta,v_delta);
  Gdk::Cairo::set_source_pixbuf(cr,m_rook,h_delta,0);
  cr->fill();
  
  cr->rectangle(0,v_delta,h_delta,2*v_delta);
  Gdk::Cairo::set_source_pixbuf(cr,m_bishop,0,v_delta);
  cr->fill();

  cr->rectangle(h_delta,v_delta,2*h_delta,2*v_delta);
  Gdk::Cairo::set_source_pixbuf(cr,m_knight,h_delta,v_delta);
  cr->fill();

  cr->paint();
  return true;

}
