/*

Copyright (C) 2019 Werner Taelemans, Belgium

This file is part of Galjoen.

Galjoen is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; version 3 of the License.

Galjoen is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with Galjoen; see the file COPYING.  If not, see
<http://www.gnu.org/licenses/>.

*/

#ifndef GTKMM_PROMOCHOICEEVENT_H
#define GTKMM_PROMOCHOICEEVENT_H


#include"promochoicedraw.h"
#include<gtkmm/eventbox.h>


class PromoChoiceEvent : public Gtk::EventBox
{
 public:
  PromoChoiceEvent(const PromoChoiceEvent&);
  PromoChoiceEvent(const Glib::RefPtr<Gdk::Pixbuf>&,
		   const Glib::RefPtr<Gdk::Pixbuf>&,
		   const Glib::RefPtr<Gdk::Pixbuf>&,
		   const Glib::RefPtr<Gdk::Pixbuf>&);
  virtual ~PromoChoiceEvent();
  sigc::signal<bool> signal_choice_made;

  int get_choice()const;

 protected:
  virtual bool on_eventbox_button_press(GdkEventButton*);
 
 private:
  PromoChoiceDraw drawing;
  int m_choice;
};



#endif // GTKMM_PROMOCHOICEEVENT_H

